## uhd 3.12.0.0

=== mpm/lib/CMakeLists.txt ===
#
# Copyright 2017 Ettus Research, National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

SET(UHD_HOST_ROOT ${CMAKE_SOURCE_DIR}/../host)

ADD_SUBDIRECTORY(dboards)
ADD_SUBDIRECTORY(chips)
ADD_SUBDIRECTORY(spi)
ADD_SUBDIRECTORY(types)

if(ENABLE_MYKONOS)
    ADD_SUBDIRECTORY(mykonos)
endif(ENABLE_MYKONOS)

USRP_PERIPHS_ADD_OBJECT(periphs
    exception.cpp
    xbar_iface.cpp
    ${UHD_HOST_ROOT}/lib/exception.cpp
)

# vim: set sw=4 et:

=== mpm/python/CMakeLists.txt ===
#
# Copyright 2017 Ettus Research, National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# This file included, use CMake directory variables
########################################################################

if(MPM_DEVICE STREQUAL "n3xx")
    ADD_LIBRARY(pyusrp_periphs SHARED pyusrp_periphs/n3xx/pyusrp_periphs.cpp)
endif(MPM_DEVICE STREQUAL "n3xx")

TARGET_INCLUDE_DIRECTORIES(pyusrp_periphs PUBLIC
    ${PYTHON_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/lib/
    ${UHD_HOST_ROOT}/lib/usrp/common
)
TARGET_LINK_LIBRARIES(pyusrp_periphs ${Boost_PYTHON_LIBRARY} ${Boost_LIBRARIES} usrp-periphs)
ADD_CUSTOM_COMMAND(TARGET pyusrp_periphs POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/libpyusrp_periphs.so ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/libpyusrp_periphs.so)

SET(USRP_MPM_FILES "")
ADD_SUBDIRECTORY(usrp_mpm)

SET(OUTPUT      "${CMAKE_CURRENT_BINARY_DIR}/build/timestamp")
SET(SETUP_PY_IN "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
SET(SETUP_PY    "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
SET(PERIPH_MGR_INIT_IN "${CMAKE_CURRENT_SOURCE_DIR}/usrp_mpm/periph_manager/__init__.py.in")
SET(PERIPH_MGR_INIT "${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/periph_manager/__init__.py")

CONFIGURE_FILE(${SETUP_PY_IN} ${SETUP_PY})
CONFIGURE_FILE(${PERIPH_MGR_INIT_IN} ${PERIPH_MGR_INIT})
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/usrp_hwd.py" "${CMAKE_CURRENT_BINARY_DIR}/usrp_hwd.py" COPYONLY)

ADD_CUSTOM_COMMAND(OUTPUT ${OUTPUT}
     COMMAND ${CMAKE_COMMAND}  -DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}" -DBINARY_DIR="${CMAKE_CURRENT_BINARY_DIR}"  -P ${CMAKE_CURRENT_SOURCE_DIR}/copy_python_module.cmake
     COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} -q build
     COMMAND ${CMAKE_COMMAND} -E touch ${OUTPUT}
     DEPENDS ${USRP_MPM_FILES})
ADD_CUSTOM_TARGET(usrp_mpm ALL DEPENDS ${OUTPUT} pyusrp_periphs)

EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c
    "from __future__ import print_function; from distutils import sysconfig; print(sysconfig.get_python_lib(plat_specific=True, prefix=''))"
    OUTPUT_VARIABLE USRP_MPM_PYTHON_DIR OUTPUT_STRIP_TRAILING_WHITESPACE
)
INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build/lib/usrp_mpm DESTINATION ${CMAKE_INSTALL_PREFIX}/${USRP_MPM_PYTHON_DIR})
INSTALL(PROGRAMS
    aurora_bist_test.py
    n3xx_bist
    usrp_hwd.py
    DESTINATION ${RUNTIME_DIR}
)

=== mpm/lib/dboards/CMakeLists.txt ===
#
# Copyright 2017 Ettus Research, National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# This file included, use CMake directory variables
########################################################################

if(ENABLE_MAGNESIUM)
    USRP_PERIPHS_ADD_OBJECT(dboards
        magnesium_manager.cpp
    )
endif(ENABLE_MAGNESIUM)

=== mpm/lib/mykonos/CMakeLists.txt ===
#
# Copyright 2017 Ettus Research, National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# This file included, use CMake directory variables
########################################################################

MACRO(MYKONOS_APPEND_SOURCES)
    SET(mykonos_sources ${mykonos_sources})
    LIST(APPEND mykonos_sources ${ARGV})
    SET(mykonos_sources ${mykonos_sources} PARENT_SCOPE)
ENDMACRO(MYKONOS_APPEND_SOURCES)

SET(mykonos_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/ad937x_ctrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ad937x_device.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ad937x_spi_iface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/adi_ctrl.cpp
    ${UHD_HOST_ROOT}/lib/types/ranges.cpp
)

ADD_SUBDIRECTORY(adi)
ADD_SUBDIRECTORY(config)

USRP_PERIPHS_ADD_OBJECT(mykonos ${mykonos_sources})

=== usrp3/top/e300/Makefile ===
#
# Copyright 2015 Ettus Research LLC
#

# NOTE: All comments prefixed with a "##" will be displayed as a part of the "make help" target
##-------------------
##USRP E3X0 FPGA Help
##-------------------
##Usage:
## make <Targets> <Options>
##
##Output:
## build/usrp_<product>_fpga_<image_type>.bit:    Configuration bitstream with header
## build/usrp_<product>_fpga_<image_type>.bin:    Configuration bitstream without header
## build/usrp_<product>_fpga_<image_type>.rpt:    Build report (includes utilization and timing summary)

# Option to stop after RTL elaboration. Use this flag as a synthesis check.
ifdef CHECK
TARGET = rtl
else
TARGET = bin
endif
TOP ?= e300

# vivado_build($1=Device, $2=SG, $3=Definitions)
vivado_build = make -f Makefile.e300.inc $(TARGET) NAME=$@ ARCH=zynq PART_ID=$1/clg484/-$2 TOP_MODULE=$(TOP) EXTRA_DEFS="$3"

# post_build($1=Device, $2=TYPE, $3=SG)
post_build = @\
	mkdir -p build; \
	echo "Exporting bitstream files..."; \
	cp build-$(1)$(2)$(3)/e300.bin build/usrp_`echo $(1) | tr A-Z a-z`_fpga$(2)$(3).bin; \
	cp build-$(1)$(2)$(3)/e300.bit build/usrp_`echo $(1) | tr A-Z a-z`_fpga$(2)$(3).bit; \
	echo "Exporting build report..."; \
	cp build-$(1)$(2)$(3)/build.rpt build/usrp_`echo $(1) | tr A-Z a-z`_fpga$(2)$(3).rpt; \
	echo "Build DONE ... $(1)";

##
##Supported Targets
##-----------------
all: E3XX_idle E3XX_idle_sg3 E310 E310_sg3 ##(Default target)

E3XX_idle: ##Build USRP E3XX idle design.
	$(call vivado_build,xc7z020,1,E3XX_IDLE_IMAGE=1)
	$(call post_build,E3XX,_idle,)

E3XX_idle_sg3: ##Build USRP E3XX idle design.
	$(call vivado_build,xc7z020,3,E3XX_IDLE_IMAGE=1 E3XX_SG3)
	$(call post_build,E3XX,_idle_,sg3)

E310: ##Build USRP E310 design for SG1 device.
	$(call vivado_build,xc7z020,1,E310)
	$(call post_build,E310,,)

E310_sg3: ##Build USRP E310 design for SG3 device.
	$(call vivado_build,xc7z020,3,E310 E3XX_SG3)
	$(call post_build,E310,_,sg3)

E310_dram_test: ##Build USRP E310 design with DRAM test.
	$(call vivado_build,xc7z020,1,E310 DRAM_TEST)
	$(call post_build,E310,_dram_test,)

E310_dram_test_sg3: ##Build USRP E310 design with DRAM test.
	$(call vivado_build,xc7z020,3,E310 DRAM_TEST E3XX_SG3)
	$(call post_build,E310,_dram_test_,sg3)

clean: ##Clean up all itarget build outputs.
	@echo "Cleaning targets..."
	@rm -rf build-E3*
	@rm -rf build

cleanall: ##Clean up all target and ip build outputs.
	@echo "Cleaning targets and IP..."
	@rm -rf build-ip
	@rm -rf build-E3*
	@rm -rf build

help: ## Show this help message.
	@grep -h "##" Makefile | grep -v "\"##\"" | sed -e 's/\\$$//' | sed -e 's/##//'

##
##Supported Options
##-----------------
##GUI=1        Launch the build in the Vivado GUI.
##CHECK=1      Launch the syntax checker instead of building a bitfile.
##TOP=<module> Specify a top module for syntax checking. (Optional. Default is the bitfile top)

.PHONY: all clean cleanall E310 E310_sg3 E3XX_idle E3XX_idle_SG3 help

=== usrp3/top/n3xx/Makefile ===
#
# Copyright 2016-2017 Ettus Research LLC
#

# NOTE: All comments prefixed with a "##" will be displayed as a part of the "make help" target
##-------------------
##USRP N3XX FPGA Help
##-------------------
##Usage:
## make <Targets> <Options>
##
##Output:
## build/usrp_<product>_fpga_<image_type>.bit:    Configuration bitstream with header
## build/usrp_<product>_fpga_<image_type>.dts:    Device tree source file
## build/usrp_<product>_fpga_<image_type>.rpt:    Build report (includes utilization and timing summary)

# Debug Options
# Uncomment this line or add to make arg to omit radio_clk (sourced from db) and use bus_clk as radio_clk
# OPTIONS += NO_DB=1
# Uncomment this line to add two example Aurora loopback lanes on the general NPIO bus.
# OPTIONS += NPIO_LANES=2
# Uncomment this line to add four example Aurora loopback lanes on the QSFP NPIO bus.
# OPTIONS += QSFP_LANES=4

HG_DEFS=SFP0_1GBE=1   SFP1_10GBE=1  BUILD_1G=1     BUILD_10G=1    $(OPTIONS)
XG_DEFS=SFP0_10GBE=1  SFP1_10GBE=1  BUILD_10G=1                   $(OPTIONS)
HA_DEFS=SFP0_1GBE=1   SFP1_AURORA=1 BUILD_1G=1     BUILD_AURORA=1 $(OPTIONS)
XA_DEFS=SFP0_10GBE=1  SFP1_AURORA=1 BUILD_10G=1    BUILD_AURORA=1 $(OPTIONS)
AA_DEFS=SFP0_AURORA=1 SFP1_AURORA=1 BUILD_AURORA=1                $(OPTIONS)

# Option to stop after RTL elaboration. Use this flag as a synthesis check.
ifdef CHECK
TARGET = rtl
else
TARGET = bin
endif
TOP ?= n3xx

# vivado_build($1=Device, $2=Definitions)
vivado_build = make -f Makefile.n3xx.inc $(TARGET) NAME=$@ ARCH=$(XIL_ARCH_$1) PART_ID=$(XIL_PART_ID_$1) $2 TOP_MODULE=$(TOP) EXTRA_DEFS="$2"

# vivado_build($1=Device, $2=Option)
post_build = @\
	mkdir -p build; \
	echo "Exporting bitstream file..."; \
	cp build-$(1)_$(2)/n3xx.bit build/usrp_`echo $(1) | tr A-Z a-z`_fpga_$(2).bit; \
	echo "Exporting build report..."; \
	cp build-$(1)_$(2)/build.rpt build/usrp_`echo $(1) | tr A-Z a-z`_fpga_$(2).rpt; \
	echo "Build DONE ... $(1)_$(2)";

##
##Supported Targets
##-----------------

all:      N300_HG N300_XG N310_HG N310_XG ##(Default target)

##N310_HG:  1GigE on SFP+ Port0, 10Gig on SFP+ Port1.
N310_HG:  build/usrp_n310_fpga_HG.dts
	$(call vivado_build,N310,$(HG_DEFS) N310=1)
	$(call post_build,N310,HG)

##N310_XG:  10GigE on SFP+ Port0, 10Gig on SFP+ Port1.
N310_XG: build/usrp_n310_fpga_XG.dts
	$(call vivado_build,N310,$(XG_DEFS) N310=1)
	$(call post_build,N310,XG)

##N310_HA:  1Gig on SFP+ Port0, Aurora on SFP+ Port1.
N310_HA: build/usrp_n310_fpga_HA.dts
	$(call vivado_build,N310,$(HA_DEFS) N310=1)
	$(call post_build,N310,HA)

##N310_XA:  10Gig on SFP+ Port0, Aurora on SFP+ Port1.
N310_XA: build/usrp_n310_fpga_XA.dts
	$(call vivado_build,N310,$(XA_DEFS) N310=1)
	$(call post_build,N310,XA)

##N310_AA:  Aurora on SFP+ Port0, Aurora on SFP+ Port1.
N310_AA: build/usrp_n310_fpga_AA.dts
	$(call vivado_build,N310,$(AA_DEFS) N310=1)
	$(call post_build,N310,AA)

##N300_HG:  1GigE on SFP+ Port0, 10Gig on SFP+ Port1.
N300_HG:  build/usrp_n300_fpga_HG.dts
	$(call vivado_build,N300,$(HG_DEFS) N300=1)
	$(call post_build,N300,HG)

##N300_XG:  10GigE on SFP+ Port0, 10Gig on SFP+ Port1.
N300_XG: build/usrp_n300_fpga_XG.dts
	$(call vivado_build,N300,$(XG_DEFS) N300=1)
	$(call post_build,N300,XG)

##N300_HA:  1Gig on SFP+ Port0, Aurora on SFP+ Port1.
N300_HA: build/usrp_n300_fpga_HA.dts
	$(call vivado_build,N300,$(HA_DEFS) N300=1)
	$(call post_build,N300,HA)

##N300_XA:  10Gig on SFP+ Port0, Aurora on SFP+ Port1.
N300_XA: build/usrp_n300_fpga_XA.dts
	$(call vivado_build,N300,$(XA_DEFS) N300=1)
	$(call post_build,N300,XA)

##N300_AA:  Aurora on SFP+ Port0, Aurora on SFP+ Port1.
N300_AA: build/usrp_n300_fpga_AA.dts
	$(call vivado_build,N300,$(AA_DEFS) N300=1)
	$(call post_build,N300,AA)

build/%.dts: dts/%.dts dts/*.dtsi
	-mkdir -p build
	${CC} -o $@ -E -I dts -nostdinc -undef -x assembler-with-cpp -D__DTS__ $<

clean:    ##Clean up all target build outputs.
	@echo "Cleaning targets..."
	@rm -rf build-N3*_*
	@rm -rf build

cleanall: ##Clean up all target and ip build outputs.
	@echo "Cleaning targets and IP..."
	@rm -rf build-ip
	@rm -rf build-N3*_*
	@rm -rf build

help:     ##Show this help message.
	@grep -h "##" Makefile | grep -v "\"##\"" | sed -e 's/\\$$//' | sed -e 's/##//'

##
##Supported Options
##-----------------
##GUI=1        Launch the build in the Vivado GUI.
##CHECK=1      Launch the syntax checker instead of building a bitfile.
##TOP=<module> Specify a top module for syntax checking. (Optional. Default is the bitfile top)

.PHONY: all clean cleanall help

=== usrp3/top/x300/Makefile ===
#
# Copyright 2012-2016 Ettus Research LLC
#

# NOTE: All comments prefixed with a "##" will be displayed as a part of the "make help" target 
##-------------------
##USRP X3X0 FPGA Help
##-------------------
##Usage:
## make <Targets> <Options>
##
##Output:
## build/usrp_<product>_fpga_<image_type>.bit:    Configuration bitstream with header
## build/usrp_<product>_fpga_<image_type>.bin:    Configuration bitstream without header
## build/usrp_<product>_fpga_<image_type>.lvbitx: Configuration bitstream for PCIe (NI-RIO)
## build/usrp_<product>_fpga_<image_type>.rpt:    Build report (includes utilization and timing summary)

# Debug Options
# Uncomment the following line to add a debug UART on GPIO 10 & 11
#OPTIONS += DEBUG_UART=1

CREATE_LVBITX=python ../../lib/io_port2/create-lvbitx.py

GIGE_DEFS=BUILD_1G=1 SFP0_1GBE=1 SFP1_1GBE=1 $(OPTIONS)
HG_DEFS=BUILD_1G=1 BUILD_10G=1 SFP0_1GBE=1 SFP1_10GBE=1 $(OPTIONS)
XG_DEFS=BUILD_10G=1 SFP0_10GBE=1 SFP1_10GBE=1 $(OPTIONS)
HA_DEFS=BUILD_1G=1 BUILD_AURORA=1 SFP0_1GBE=1 SFP1_AURORA=1 $(OPTIONS)
XA_DEFS=BUILD_10G=1 BUILD_AURORA=1 SFP0_10GBE=1 SFP1_AURORA=1 $(OPTIONS)

# Option to stop after RTL elaboration. Use this flag as a synthesis check.
ifdef CHECK
TARGET = rtl
else
TARGET = bin
endif
TOP ?= x300

# vivado_build($1=Device, $2=Definitions)
vivado_build = make -f Makefile.x300.inc $(TARGET) NAME=$@ ARCH=$(XIL_ARCH_$1) PART_ID=$(XIL_PART_ID_$1) $2 TOP_MODULE=$(TOP) EXTRA_DEFS="$2"

# vivado_build($1=Device, $2=Option)
post_build = @\
	mkdir -p build; \
	echo "Exporting bitstream files..."; \
	cp build-$(1)_$(2)/x300.bin build/usrp_`echo $(1) | tr A-Z a-z`_fpga_$(2).bin; \
	cp build-$(1)_$(2)/x300.bit build/usrp_`echo $(1) | tr A-Z a-z`_fpga_$(2).bit; \
	echo "Generating LVBITX..."; \
	$(CREATE_LVBITX) --input-bin=build-$(1)_$(2)/x300.bin --output-lvbitx=build/usrp_`echo $(1) | tr A-Z a-z`_fpga_$(2).lvbitx --device="USRP $(1)" x3x0_base.lvbitx; \
	cp -f x3x0_base.lvbitx build/`echo $(1) | tr A-Z a-z`.lvbitx_base; \
	echo "Exporting build report..."; \
	cp build-$(1)_$(2)/build.rpt build/usrp_`echo $(1) | tr A-Z a-z`_fpga_$(2).rpt; \
	echo "Build DONE ... $(1)_$(2)";

##
##Supported Targets
##-----------------

all:      X300_HG X310_HG X300_XG X310_XG ##(Default target)

X310_1G:  ##USRP X310. 1GigE on both SFP+ ports. DRAM TX FIFO (Experimental!).
	$(call vivado_build,X310,$(GIGE_DEFS) X310=1)
	$(call post_build,X310,1G)

X300_1G:  ##USRP X300. 1GigE on both SFP+ ports. DRAM TX FIFO (Experimental!).
	$(call vivado_build,X300,$(GIGE_DEFS) X300=1)
	$(call post_build,X300,1G)

X310_HG:  ##USRP X310. 1GigE on SFP+ Port0, 10Gig on SFP+ Port1. DRAM TX FIFO.
	$(call vivado_build,X310,$(HG_DEFS) X310=1)
	$(call post_build,X310,HG)

X300_HG:  ##USRP X300. 1GigE on SFP+ Port0, 10Gig on SFP+ Port1. DRAM TX FIFO.
	$(call vivado_build,X300,$(HG_DEFS) X300=1)
	$(call post_build,X300,HG)

X310_XG:  ##USRP X310. 10GigE on both SFP+ ports. DRAM TX FIFO.
	$(call vivado_build,X310,$(XG_DEFS) X310=1)
	$(call post_build,X310,XG)

X300_XG:  ##USRP X300. 10GigE on both SFP+ ports. DRAM TX FIFO.
	$(call vivado_build,X300,$(XG_DEFS) X300=1)
	$(call post_build,X300,XG)

X310_HA:  ##USRP X310. 1Gig on SFP+ Port0, Aurora on SFP+ Port1. DRAM TX FIFO (Experimental!).
	$(call vivado_build,X310,$(HA_DEFS) X310=1)
	$(call post_build,X310,HA)

X300_HA:  ##USRP X300. 1Gig on SFP+ Port0, Aurora on SFP+ Port1. DRAM TX FIFO (Experimental!).
	$(call vivado_build,X300,$(HA_DEFS) X300=1)
	$(call post_build,X300,HA)

X310_XA:  ##USRP X310. 10Gig on SFP+ Port0, Aurora on SFP+ Port1. DRAM TX FIFO (Experimental!).
	$(call vivado_build,X310,$(XA_DEFS) X310=1)
	$(call post_build,X310,XA)

X300_XA:  ##USRP X300. 10Gig on SFP+ Port0, Aurora on SFP+ Port1. DRAM TX FIFO (Experimental!).
	$(call vivado_build,X300,$(XA_DEFS) X300=1)
	$(call post_build,X300,XA)


clean:    ##Clean up all target build outputs.
	@echo "Cleaning targets..."
	@rm -rf build-X3*_*
	@rm -rf build

cleanall: ##Clean up all target and ip build outputs.
	@echo "Cleaning targets and IP..."
	@rm -rf build-ip
	@rm -rf build-X3*_*
	@rm -rf build

help:     ##Show this help message.
	@grep -h "##" Makefile | grep -v "\"##\"" | sed -e 's/\\$$//' | sed -e 's/##//'

##
##Supported Options
##-----------------
##GUI=1        Launch the build in the Vivado GUI.
##CHECK=1      Launch the syntax checker instead of building a bitfile.
##TOP=<module> Specify a top module for syntax checking. (Optional. Default is the bitfile top)

.PHONY: all clean cleanall help

=== host/lib/usrp/e300/CMakeLists.txt ===
#
# Copyright 2013-2015 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# This file included, use CMake directory variables
########################################################################

########################################################################
# Conditionally configure the USRP-E300 support
########################################################################
find_package(UDev)

IF(ENABLE_E300)
    LIST(APPEND E300_SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_impl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_io_impl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_fifo_config.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_sysfs_hooks.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_network.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_global_regs.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_spi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_sensor_manager.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_i2c.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_eeprom_manager.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_common.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/e300_remote_codec_ctrl.cpp
    )
    LIBUHD_APPEND_SOURCES(${E300_SOURCES})
    IF(UDEV_FOUND AND NOT E300_FORCE_NETWORK)
        INCLUDE_DIRECTORIES(${UDEV_INCLUDE_DIR})
        LIBUHD_APPEND_LIBS(${UDEV_LIBS})
        SET_SOURCE_FILES_PROPERTIES(
            ${E300_SOURCES}
            PROPERTIES COMPILE_DEFINITIONS "E300_NATIVE=1"
        )
    ENDIF(UDEV_FOUND AND NOT E300_FORCE_NETWORK)

    IF(ENABLE_GPSD)
        SET_SOURCE_FILES_PROPERTIES(
            ${CMAKE_CURRENT_SOURCE_DIR}/e300_impl.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/e300_impl.hpp
            PROPERTIES COMPILE_DEFINITIONS "E300_GPSD=1"
        )
    ENDIF(ENABLE_GPSD)
ENDIF(ENABLE_E300)

=== mpm/include/mpm/ad937x/CMakeLists.txt ===
#
# Copyright 2017 Ettus Research, National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#
INSTALL(FILES
    adi_ctrl.hpp
    ad937x_ctrl.hpp
    DESTINATION ${INCLUDE_DIR}/mpm/mykonos
)

=== mpm/python/usrp_mpm/periph_manager/CMakeLists.txt ===
#
# Copyright 2017 Ettus Research, National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# This file included, use CMake directory variables
########################################################################
SET(USRP_MPM_FILES ${USRP_MPM_FILES})
SET(USRP_MPM_PERIPHMGR_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/__init__.py.in
    ${CMAKE_CURRENT_SOURCE_DIR}/base.py
    ${CMAKE_CURRENT_SOURCE_DIR}/n3xx.py
    ${CMAKE_CURRENT_SOURCE_DIR}/n3xx_periphs.py
    ${CMAKE_CURRENT_SOURCE_DIR}/test.py
    )
LIST(APPEND USRP_MPM_FILES ${USRP_MPM_PERIPHMGR_FILES})
SET(USRP_MPM_FILES ${USRP_MPM_FILES} PARENT_SCOPE)

=== usrp3/lib/rfnoc/noc_block_addsub_tb/Makefile ===
#
# Copyright 2016 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: LGPL-3.0-or-later
#

#-------------------------------------------------
# Top-of-Makefile
#-------------------------------------------------
# Define BASE_DIR to point to the "top" dir
BASE_DIR = $(abspath ../../../top)
# Include viv_sim_preample after defining BASE_DIR
include $(BASE_DIR)/../tools/make/viv_sim_preamble.mak

#-------------------------------------------------
# Testbench Specific
#-------------------------------------------------
# Define only one toplevel module
SIM_TOP = noc_block_addsub_tb

# Add test bench, user design under test, and
# additional user created files
SIM_SRCS = \
$(abspath noc_block_addsub_tb.sv)

#-------------------------------------------------
# Bottom-of-Makefile
#-------------------------------------------------
# Include all simulator specific makefiles here
# Each should define a unique target to simulate
# e.g. xsim, vsim, etc and a common "clean" target
include $(BASE_DIR)/../tools/make/viv_simulator.mak

=== usrp3/lib/rfnoc/noc_block_ddc_tb/Makefile ===
#
# Copyright 2016 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: LGPL-3.0-or-later
#

#-------------------------------------------------
# Top-of-Makefile
#-------------------------------------------------
# Define BASE_DIR to point to the "top" dir
BASE_DIR = $(abspath ../../../top)
# Include viv_sim_preample after defining BASE_DIR
include $(BASE_DIR)/../tools/make/viv_sim_preamble.mak

#-------------------------------------------------
# IP Specific
#-------------------------------------------------
# If simulation contains IP, define the IP_DIR and point
# it to the base level IP directory
LIB_IP_DIR = $(BASE_DIR)/../lib/ip

# Include makefiles and sources for all IP components
# *after* defining the LIB_IP_DIR
include $(LIB_IP_DIR)/axi_fft/Makefile.inc
include $(LIB_IP_DIR)/complex_to_magphase/Makefile.inc
include $(BASE_DIR)/x300/coregen_dsp/Makefile.srcs

DESIGN_SRCS += $(abspath \
$(LIB_IP_AXI_FFT_SRCS) \
$(LIB_IP_COMPLEX_TO_MAGPHASE_SRCS) \
$(COREGEN_DSP_SRCS) \
)

#-------------------------------------------------
# Testbench Specific
#-------------------------------------------------
# Define only one toplevel module
SIM_TOP = noc_block_ddc_tb

# Add test bench, user design under test, and
# additional user created files
SIM_SRCS = $(abspath \
./noc_block_ddc_tb.sv \
../noc_block_ddc.v \
)

MODELSIM_USER_DO = $(abspath wave.do)

#-------------------------------------------------
# Bottom-of-Makefile
#-------------------------------------------------
# Include all simulator specific makefiles here
# Each should define a unique target to simulate
# e.g. xsim, vsim, etc and a common "clean" target
include $(BASE_DIR)/../tools/make/viv_simulator.mak

=== debian/changelog ===
uhd (3.12.0.0-3build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 13:04:16 +0000

uhd (3.12.0.0-3) unstable; urgency=medium

  * ENABLE_RFNOC in debian/rules

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 25 Jun 2018 15:02:24 -0400

uhd (3.12.0.0-2) unstable; urgency=medium

  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 07 Jun 2018 22:19:53 -0400

uhd (3.12.0.0-1) experimental; urgency=medium

  * New upstream release
    upload to experimental first to start ABI migration

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 06 Jun 2018 13:23:58 -0400

uhd (3.12.0.0-0ubuntu1) trusty; urgency=low

  * N3x0: Add White Rabbit support, add N300 support, standard BIST
          includes fan, fix issue with 1GigE, switch to 2 radio blocks
          with 2 channels each, upgrade TDC to version 2.0, fix issue in
          ARM deframer
  * X300: Enable BasicRX to use A/B/AB/BA muxing setups, more consistent
          logging, fix enumeration issue with TwinRX
  * USRP2/N2x0: Re-add ability to modulate in the DAC, improve ISE
                settings to better meet timing
  * B205mini: Fix global reset, improve timing in b205_ref_pll
  * UHD: Remove a lot of Boost usage, mostly replaced by C++11 features,
         more unit tests, fix Boost 1.67 compatibility, fix compiler
         warnings, add API to query clock rate range, fix get_usrp_?x_info
  * MPM: Refactored N3xx code, moved C++ standard to 14, refactor
         Boost.Python bindings, use CMake variable MPM_DEVICE
  * Logging: Allow disabling fastpath msgs at runtime
  * Docs: Clarified meaning of DSP frequencies, improved manual
          section on synchronization, added some known issues to B100,
          USRP2, and USRP1, update test test procedure description
  * Examples: Improved benchmark_rate (added failure thresholds, fixed
    incorrect calculation of samples on drops, fixed timeout values),
    minor fixes to txrx_loopback_to_file
  * Utils: Handle U's in calibration tools, create-lvbitx.py is now Py3k
           compatible, fixed git-hash.sh
  * RFNoC: DDCs/DUCs use DDSes instead of CORDIC, add DMA-based replay
           block in FPGA, add 64-bit support to axi_wrapper, add compat
           number to radio block,
  * Debian: Fix rules file, fix Changelog format
  * Fix license headers
  * This release includes all bugfixes and features from previous
    releases, in particular, the 3.11.* release cycle

 -- Ettus Research <packages@ettus.com>  Tue, 5 Jun 2018 10:38:00 -0800

uhd (3.11.1.0-1) unstable; urgency=medium

  * New upstream release
  * update watch file

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 21 May 2018 00:05:20 -0400

uhd (3.11.1.0-0ubuntu1) trusty; urgency=low

  * N310: fix compiler warnings
  * N310: Implement digital loopback
  * N3xx: Add N3xx devtest
  * X300: Properly coerce master clock rate (tick rate)
  * X300: handle bad weak_ptr during pcie discovery
  * X300: handle bad weak_ptr during pcie discovery
  * X300: Fix check_radio_config() to fix errors when using a single dboard
          in slot A
  * B200: docs: Suggest modifying recv_frame_size for more stability
  * B200: Fix bandwidth warnings and ranges
  * N2xx: Fix regression issue that limited tuning range
  * UBX: Change antenna functions to coercers on antenna/value properties
  * adf4002: Fix register programming for power down bit
  * UHD: Fix config file path for some Windows builds
  * UHD: Add operators == and != for uhd::dict
  * UHD: Add device_addr_t constructor from map
  * UHD: Fix range of gain group to skip gains with zero step
  * UHD: Changes to support Boost 1.67
  * UHD: Correctly set end of burst flag in RX metadata
  * UHD: Reduce usage of boost::assign, boost::this_thread::sleep, and boost:bind
  * UHD: Update multi_usrp::get_usrp_?x_info() for MPM devices
  * UHD: Refactor static const values to fix linker errors in niusrprio
  * mpm: cmake: Add git hash and version info to Python module
  * mpm: Add reference counters to UIO
  * mpm: Add offset to EEPROM reads
  * mpm: Disable PPS out during initialization
  * mpm: Update cmake to find the correct python3
  * mpm: Bump maximum supported revision to 5 (Rev F)
  * mpm: Fixed db slot typo in db-id
  * mpm: Increased claim timeout, made a separate RPC connection for claim, and
         added asyn calls for long RPC executions
  * mpm: Improve xport<->SFP mapping algorithm
  * mpmd: Improved find routine to fail fast and verify correct device is
          reachable
  * mpmd: Add missing virtual destructors
  * rfnoc/x300: Make sure peek32() and peek64() are called with actual addresses
  * rfnoc: ctrl_iface cleanup
  * rfnoc radio: Improve warning for too many samples requested
  * rfnoc radio: get_rx_stream resets sequence num
  * examples: Increase settling time, increase buffer fill time, and fix subdevice
              selection in txrx_loopback_to_file
  * examples: Improvements to benchmark_rate
  * utils: downloader supports multiple RegExs
  * utils: Added code to handle underruns during self calibration
  * utils: Fix 30s tiemout in query_gpsdo_sensors
  * logging: Improve style consistency and demote some messages
  * logging: Fix UHD_LOG_FILE cmake variable
  * Docs: Add Known Issues section to USRP1, B100, and USRP2/N2x0
  * Docs: Hide dependencies directory from Doxygen
  * Docs: Clarify subdev specs and magnesium driver usage for N300/N310
  * cmake: Improve warning for missing requests
  * cmake: update NSIS template
  * cmake: Remove images downloader section (replaced by manifest)

 -- Ettus Research <packages@ettus.com>  Wed, 16 May 2018 10:05:17 -0800

uhd (3.11.0.1-1) unstable; urgency=medium

  * New upstream release
  * use_SOURCE_DATE_EPOCH patch

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 31 Mar 2018 09:45:31 -0400

uhd (3.11.0.0-1) experimental; urgency=medium

  * Debian build


=== debian/control ===
Source: uhd
Section: science
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper (>= 10),
	       doxygen,
	       doxygen-latex,
	       graphviz [!powerpcspe],
               libboost-date-time-dev,
	       libboost-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libgps-dev,
               libncurses5-dev,
               liborc-0.4-dev,
	       libudev-dev [linux-any],
               libusb-1.0-0-dev [linux-any],
               libusb2-dev [kfreebsd-any],
               pkg-config,
               python-mako,
	       python-requests
Standards-Version: 4.1.4
Homepage: http://www.ettus.com/sdr-software/detail/usrp-hardware-driver
Vcs-Browser: http://salsa.debian.org/bottoms/pkg-uhd
Vcs-Git: git://salsa.debian.org/bottoms/pkg-uhd.git

Package: uhd-host
Architecture: any
Depends: adduser,
         libuhd3.12.0 (= ${binary:Version}),
         python,
         python-requests,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: curl, procps, python-tk
Suggests: gnuradio, fdisk | util-linux (<< 2.29.2-3~)
Description: universal hardware driver for Ettus Research products - host apps
 Host utilities for the Universal Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package includes the uhd_find_devices application to locate and
 configure attached peripherals, the uhd_usrp_probe application to
 display hardware configuration information and Doxygen generated
 documentation.

Package: libuhd3.12.0
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: gnuradio
Multi-Arch: same
Description: universal hardware driver for Ettus Research products - library
 Host library for the Universal Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.

Package: libuhd-dev
Architecture: any
Section: libdevel
Depends: libuhd3.12.0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: gnuradio
Multi-Arch: same
Description: universal hardware driver for Ettus Research products - headers
 Host library for the Universal Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package contains the header files for developing with libuhd.
 Doxygen generated documentation is in the uhd-host package.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
#GITREV=$(shell echo $(VER) | sed -rne 's,([0-9]).([0-9].).([0-9]).([0-9]),release_00\1_0\2_00\3_00\4,p')
GITREV=v3.12.0.0
%:
	dh $@ --sourcedirectory=host --builddirectory=build

override_dh_acc:
	- dh_acc $@
	- cat logs/libuhd-dev/*/log.txt

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DENABLE_RFNOC=True \
	                      -DPKG_LIB_DIR="/usr/lib/uhd" -DDOXYGEN_HAVE_DOT=True

# RFNoC test 30 files if no USRP available
override_dh_auto_test:
	- dh_auto_test

override_dh_auto_install:
	cp debian/uhd-host.limits debian/uhd-host/etc/security/limits.d/uhd.conf
	cp debian/uhd-host.sysctl debian/uhd-host/etc/sysctl.d/uhd-usrp2.conf
	dh_auto_install

get-orig-source:
	echo $(VER) $(GITREV)
	git clone git://github.com/EttusResearch/uhd.git
	cd uhd && git submodule init
	cd uhd && git submodule update
	cd uhd && git archive --format=tar --prefix=uhd-$(VER)/  $(GITREV) | xz > ../../uhd_$(VER).orig.tar.xz
	cd uhd && git checkout $(GITREV)
	cd uhd && rm -rf fpga-src/.git fpga-src/.gitignore
	cd uhd && tar cf - fpga-src | xz > ../../uhd_$(VER).orig-fpga-src.tar.xz
	rm -rf uhd
